///////////////////////////////////////////////////////////////////////////////
// CPinnableDialog.h : Declaration of the CPinnableDialog class.
//
// Copyright 1999 David Hill - dhill@PrincipiaMathematica.com.
//
///////////////////////////////////////////////////////////////////////////////
#if !defined(__CPINNABLEDIALOG_H_INCLUDED__)
#define __CPINNABLEDIALOG_H_INCLUDED__
#if _MSC_VER >= 1000
#pragma once
#endif


// Define message to inform the parent when this dialog is closed.
#define WM_PINUPCLOSE  WM_USER + 10


class CPinnableDialog : public CDialog
{
public:
	// Construction.
	CPinnableDialog( UINT nDlgID,				// ID for the dialog template resource.
				     UINT nPinnedIconID,		// ID for the pinned icon.
				     UINT nUnpinnedIconID,	    // ID for the unpinned icon.
				     CWnd* pParent = NULL );	// Parent window, if any.

    // Utility functions.
	BOOL Show( BOOL bPinned = FALSE );
	BOOL Hide();
	BOOL Visible() const					{ return ( GetSafeHwnd() != 0 ); }
	void DeactivateAsCancel( BOOL bCancel )	{ m_bDeactivateAsCancel = bCancel; }

  	//{{AFX_DATA(CPinnableDialog)
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// Overrides.
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPinnableDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	// Generated message map functions
	//{{AFX_MSG(CPinnableDialog)
	afx_msg void    OnClose();
	virtual void    OnCancel();
	virtual void    OnOK();
	afx_msg LRESULT OnActivate( WPARAM wParam, LPARAM lParam );
	virtual BOOL    OnInitDialog();
	afx_msg void    OnSysCommand(UINT nID, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	// Protected data members.
	HICON m_hPinned;				// Icon for pinned state.
	HICON m_hUnpinned;				// Icon for unpinned state.
	BOOL  m_bPinned;				// Pinned state flag.
    UINT  m_nTemplateID;			// ID for the dialog's template.
	BOOL  m_bDeactivateAsCancel;	// Treat deactivation as cancel flag.

	// Protected member functions.
	void UpdateIcon();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif
